'CNVRT.BAS by Sue Forslev, 11/21/90
'This program will convert an ASCII text file to a delimited file
'Using user defined parameters
CLS
'LOCATE 1,1
PRINT "CNVRT "
LOCATE 2,1
PRINT "Copyright (c) 1990 by Sue Forslev"
DELAY 1
CLS
'Check for command line parameters
IF COMMAND$ <> "" THEN
   'Find the first space
   VSPACE = INSTR(COMMAND$, " ")
   'Trap for a space at the end of the command line
   IF VSPACE = LEN(COMMAND$) THEN
      VSPACE = 0
   END IF
   'If there is no space, only the ascii file was entered
   IF VSPACE = 0 THEN
      INFILE$ = COMMAND$
      IF INSTR(INFILE$, ".") = 0 THEN
         'If a suffix is not specified, add .ASC
         INFILE$ = INFILE$ + ".ASC"
      END IF
      'Go down to prompts for the other files
      GOTO TWO
   END IF
   'Get the input ascii file name from the beginning of the command line
   INFILE$ = LEFT$(COMMAND$, VSPACE - 1)
   IF INSTR(INFILE$,".") = 0 THEN
      INFILE$ = INFILE$ + ".ASC"
   END IF
   VSPACE1 = INSTR(VSPACE + 1,COMMAND$, " ")
   'Trap for a single space at the end of the command line
   IF VSPACE1 = LEN(COMMAND$) THEN
      VSPACE1 = 0
   END IF
   'Get the dat file name and the output file name in the same way
   IF VSPACE1 = 0 THEN
      DATFILE$ = (MID$(COMMAND$, VSPACE + 1))
      IF INSTR(DATFILE$, ".") = 0 THEN
         DATFILE$ = DATFILE$ + ".DAT"
      END IF
      GOTO THREE
   END IF
   DATFILE$ = MID$(COMMAND$, VSPACE + 1, (VSPACE1 - 1) - VSPACE)
   IF INSTR(DATFILE$, ".") = 0 THEN
      DATFILE$ = DATFILE$ + ".DAT"
   END IF
   VSPACE2 = INSTR(VSPACE1 + 1,COMMAND$, " ")
   IF VSPACE2 = LEN(COMMAND$) THEN
      VSPACE2 = 0
   END IF
   IF VSPACE2 = 0 THEN
      OUTFILE$ = (MID$(COMMAND$, VSPACE1 + 1))
      IF INSTR(OUTFILE$, ".") = 0 THEN
         OUTFILE$ = OUTFILE$ + ".PRN"
      END IF
      GOTO FOUR
   END IF
   OUTFILE$ = MID$(COMMAND$, VSPACE1 + 1,(VSPACE2 - 1) - VSPACE1 )
   IF INSTR(OUTFILE$, ".") = 0 THEN
      OUTFILE$ = OUTFILE$ + ".PRN"
   END IF
   VSPACE3 = INSTR(VSPACE2 +1, COMMAND$, " ")
   IF VSPACE3 = LEN(COMMAND$) THEN
      VSPACE3 = 0
   END IF
   IF VSPACE3 = 0 THEN
      VAPP$ = MID$(COMMAND$, VSPACE2 + 1)
      GOTO START
   END IF
   VAPP$ = MID$(COMMAND$, VSPACE2 +1,(VSPACE3 - 1) - VSPACE2)
   'Get the location of a required field
   VTEST% = VAL(MID$(COMMAND$, VSPACE3 + 1))
   GOTO START
END IF
CLS
ONE:
INPUT "Please enter the .asc file to convert:  ", INFILE$
IF INFILE$ = "" THEN GOTO ONE
TWO:
INPUT "Please enter the data file for the conversion:  ",DATFILE$
IF DATFILE$ = "" THEN GOTO TWO
THREE:
INPUT "Please enter the output file for the conversion: ",OUTFILE$
IF OUTFILE$ = "" THEN GOTO THREE
FOUR:
INPUT "Append to the existing output file?  ", VAPP$
IF VAPP$ = "" THEN GOTO FOUR:
IF INSTR(DATFILE$, ".") = 0 THEN
   DATFILE$ = DATFILE$ + ".DAT"
END IF
IF INSTR(INFILE$, ".") = 0 THEN
   INFILE$ = INFILE$ + ".ASC"
END IF
IF INSTR(OUTFILE$, ".") = 0 THEN
   OUTFILE$ = OUTFILE$ + ".PRN"
END IF
ON ERROR GOTO ERROR1
OPEN DATFILE$ FOR INPUT AS #1
CLOSE
ON ERROR GOTO 0
'If the dat file exists, give the user the option to change it
IF VERR$ = "" THEN
   INPUT "Do you want to change the field definition file?(Y/N) ", VANS$
   IF UCASE$(VANS$) = "N" THEN GOTO START
   CLS
END IF
FIVE:
'This section is just straightforward data entry
INPUT "Please enter the record length of the .asc file :  ", RECLN#
IF RECLN# = 0 THEN GOTO FIVE
SIX:
INPUT "Please enter the number of fields:  ", NUMBFIELD#
IF NUMBFIELD# = 0 THEN GOTO SIX
IF UCASE$(VANS$) <> "Y" THEN GOTO START
OPEN DATFILE$ for OUTPUT as #1
WRITE# 1, RECLN#, NUMBFIELD#
FOR X = 1 TO NUMBFIELD#
    CLS
    PRINT "Field #"X
    SEVEN:
    INPUT "Please enter the first position of the field:  ", FSTART#
    IF FSTART# = 0 THEN GOTO SEVEN
    IF FSTART# = 1 THEN
       FSTART# = 0
    END IF
    EIGHT:
    INPUT "Please enter the length of the field:  ", FEND#
    IF FEND# = 0 THEN GOTO EIGHT
    NINE:
    INPUT "Is this text or numeric? (T,N - Treat date as text):  ", FTYPE$
    IF FTYPE$ = "" THEN GOTO NINE
    WRITE# 1, FSTART#, FEND#, FTYPE$
NEXT
CLOSE
START:
CLS
ON ERROR GOTO ERROR2
'See if the output file exists,
IF ASC(UCASE$(VAPP$)) = 89 THEN
   LOCATE 1,1
   PRINT "Locating the end of " OUTFILE$
   OPEN OUTFILE$ FOR APPEND AS #1
ELSE
   OPEN OUTFILE$ FOR OUTPUT AS #1
END IF
ON ERROR GOTO 0
OPEN INFILE$ FOR BINARY AS #2
OPEN DATFILE$ FOR INPUT AS #3
INPUT# 3, RECLN#, NUMBFIELD#
CLOSE# 3
VLEN& = 0
'Start arrays at 1 instead of 0
OPTION BASE 1
'Set up an array with the same number of elements as the number of fields
'you want to convert
DIM A$(NUMBFIELD#)
CLS
I& = 0
RECS& = 0
'First loop runs once for each record
'Variable I& contains the absolute position in the ASCII text file
'It increments by the length of the record each loop
FOR I& = 0 TO LOF(2) STEP VLEN&
IF NOT EOF(2) THEN
   SEEK #2, I&
   OPEN DATFILE$ FOR INPUT AS #3
   '  put the first line of #3 into dummy variables
   '  to get them out of the way
   INPUT# 3, VONE#, VTWO#
   X% = 0
   LOCATE 1,1
   PRINT "Converting record #" RECS&
   'Read one record's worth (length RECLN#) of the ASCII text file into
   'the variable VREC$
   GET$ #2, RECLN#, VREC$
   VLEN& = INSTR(VREC$, CHR$(10))
   IF VLEN& = 0 THEN
      VLEN& = RECLN#
   END IF
   'This loop goes through the file that defines the fields, takes out the
   'specified string, stores it to an array element, and writes it to the
   'output file
   DO WHILE NOT EOF(3)
      'X% holds the number of the array element
      VTEST$ = "N"
      X% = X% + 1
      'read the field specification
      INPUT# 3, FSTART#, FEND#, FTYPE$
      'If it's the first field, get the first FEND# characters of VREC$
      IF FSTART# = 0 THEN
         A$(X%) = LEFT$(VREC$,FEND#)
      ELSE
         'If it's the middle of VREC$, use the MID$ function instead of LEFT$
         A$(X%) = MID$(VREC$, FSTART#, FEND#)
      END IF
      'This is written for left justified files, it sets the array element to
      'a blank if there is a space at the left.
      'try this for right justified files:
      'IF MID$(VREC$, (VSTART# + VEND#, 1)) = " " THEN
      'I've never seen right justified files
      IF LEFT$(A$(X%),1) = " " THEN
         'If the required field is blank, quit converting the record
         IF X% = VTEST% THEN
            VTEST$ = "Y"
            EXIT LOOP
         END IF
         A$(X%) = ""
      END IF
      IF (FSTART# + (FEND# - 1)) >= VLEN& THEN
         IF X% = VTEST% THEN
            VTEST$ = "Y"
            EXIT LOOP
         END IF
         A$(X%) = ""
      END IF
      IF INSTR(A$(X%), CHR$(13)) > 0 THEN
         A$(X%) = LEFT$(A$(X%), INSTR(A$(X%), CHR$(13)) - 1)
      END IF
      'Add double quotes to a text element
      IF UCASE$(FTYPE$) = "T" THEN
         A$(X%) = CHR$(34) + A$(X%) + CHR$(34)
      END IF
      'Gather up the whole array
   LOOP UNTIL EOF(3)
   'Close the definition file
   CLOSE 3
   'If the record has a required field blank, don't write the record to the
   'output file
   IF VTEST$ = "Y" THEN GOTO ENDIT
   Y# = 0
   'Put all the array elements in one variable named VSTRING$
   FOR Y# = 1 to NUMBFIELD#
       IF Y# = 1 THEN
          VSTRING$ = A$(1)
       ELSE
          VSTRING$ = VSTRING$ + CHR$(44) + A$(Y#)
       END IF
   NEXT Y#
   'Print the converted record to the output file
   PRINT #1, VSTRING$
   ENDIT:
   I& = I& + VLEN&
   RECS& = RECS& + 1
ELSE
   EXIT FOR
END IF
NEXT I&
'If it's the end, close everything
CLOSE
'Go to the end
GOTO LEND:
ERROR1:
OPEN DATFILE$ FOR OUTPUT AS #1
VERR$ = "x"
RESUME NEXT
ERROR2:
OPEN OUTFILE$ FOR OUTPUT AS #1
VEXIST$ = "N"
RESUME NEXT
LEND:
END




